> ## Documentation Index
> Fetch the complete documentation index at: https://docs.getprimo.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Install a software on a device

> Install ONE Primo-managed software on ONE device via MDM. The software must already exist in your company catalog (see `getSoftwares`) and be available for install on that device. To remove it instead, use `uninstallDeviceSoftware`.

<span className="badge-write">Key: Write</span><span className="badge-company">Scope: Company</span>


## OpenAPI

````yaml https://api.getprimo.com/openapi.json post /devices/{deviceId}/software/{softwareId}/install
openapi: 3.1.1
info:
  title: Public API - BETA
  description: Read docs on https://docs.getprimo.com/
  version: '1.0'
  contact: {}
servers:
  - url: https://api.getprimo.com
security:
  - apikey: []
tags: []
paths:
  /devices/{deviceId}/software/{softwareId}/install:
    post:
      tags:
        - Devices
      summary: Install a software on a device
      description: >-
        Install ONE Primo-managed software on ONE device via MDM. The software
        must already exist in your company catalog (see `getSoftwares`) and be
        available for install on that device. To remove it instead, use
        `uninstallDeviceSoftware`.
      operationId: installDeviceSoftware
      parameters:
        - name: deviceId
          required: true
          in: path
          schema:
            type: string
        - name: softwareId
          required: true
          in: path
          schema:
            type: string
      responses:
        default:
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/DeviceSoftwareActionResult_Output'
components:
  schemas:
    DeviceSoftwareActionResult_Output:
      type: object
      properties:
        success:
          type: boolean
          const: true
        message:
          type: string
          description: A human-readable description of the action
      required:
        - success
        - message
      additionalProperties: false
  securitySchemes:
    apikey:
      scheme: bearer
      bearerFormat: API key
      type: http
      description: >-
        Use your Primo API key in the Authorization header as `Bearer
        <API_KEY>`.

````